ImmutableList
Date: 2016-05-24

com.google.common.collect

## Class ImmutableList<E>

- java.lang.Object
- - java.util.AbstractCollection<E>
  - - com.google.common.collect.ImmutableCollection<E>
    - - com.google.common.collect.ImmutableList<E>

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Iterable<E>, java.util.Collection<E>, java.util.List<E>, java.util.RandomAccess

      @GwtCompatible(serializable=true,
                     emulated=true)
      public abstract class ImmutableList<E>
      extends ImmutableCollection<E>
      implements java.util.List<E>, java.util.RandomAccess

  A `List` whose contents will never change, with many other important properties detailed at `ImmutableCollection`.

  See the Guava User Guide article on immutable collections.

  Since:
    2.0
  See Also:
    `ImmutableMap`, `ImmutableSet`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ImmutableList.Builder<E>` A builder for creating immutable list instances, especially `public static final` lists ("constant lists").

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(int index, E element)` Deprecated. Unsupported operation.
    `boolean` | `addAll(int index, java.util.Collection<? extends E> newElements)` Deprecated. Unsupported operation.
    `ImmutableList<E>` | `asList()` Returns this list instance.
    `static <E> ImmutableList.Builder<E>` | `builder()` Returns a new builder.
    `boolean` | `contains(java.lang.Object object)`
    `static <E> ImmutableList<E>` | `copyOf(java.util.Collection<? extends E> elements)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `copyOf(E[] elements)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `copyOf(java.lang.Iterable<? extends E> elements)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `copyOf(java.util.Iterator<? extends E> elements)` Returns an immutable list containing the given elements, in order.
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `hashCode()`
    `int` | `indexOf(java.lang.Object object)`
    `UnmodifiableIterator<E>` | `iterator()` Returns an unmodifiable iterator across the elements in this collection.
    `int` | `lastIndexOf(java.lang.Object object)`
    `UnmodifiableListIterator<E>` | `listIterator()`
    `UnmodifiableListIterator<E>` | `listIterator(int index)`
    `static <E> ImmutableList<E>` | `of()` Returns the empty immutable list.
    `static <E> ImmutableList<E>` | `of(E element)` Returns an immutable list containing a single element.
    `static <E> ImmutableList<E>` | `of(E e1, E e2)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5, E e6)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5, E e6, E e7)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5, E e6, E e7, E e8)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5, E e6, E e7, E e8, E e9)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5, E e6, E e7, E e8, E e9, E e10)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5, E e6, E e7, E e8, E e9, E e10, E e11)` Returns an immutable list containing the given elements, in order.
    `static <E> ImmutableList<E>` | `of(E e1, E e2, E e3, E e4, E e5, E e6, E e7, E e8, E e9, E e10, E e11, E e12, E... others)` Returns an immutable list containing the given elements, in order.
    `E` | `remove(int index)` Deprecated. Unsupported operation.
    `ImmutableList<E>` | `reverse()` Returns a view of this immutable list in reverse order.
    `E` | `set(int index, E element)` Deprecated. Unsupported operation.
    `ImmutableList<E>` | `subList(int fromIndex, int toIndex)` Returns an immutable list of the elements between the specified `fromIndex`, inclusive, and `toIndex`, exclusive.

    - ### Methods inherited from class com.google.common.collect.ImmutableCollection

      `add, addAll, clear, remove, removeAll, retainAll, toArray, toArray`

    - ### Methods inherited from class java.util.AbstractCollection

      `containsAll, isEmpty, size, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.List

      `add, addAll, clear, containsAll, get, isEmpty, remove, removeAll, retainAll, size, toArray, toArray`

- - ### Method Detail

    - #### of

          public static <E> ImmutableList<E> of()

      Returns the empty immutable list. This set behaves and performs comparably to `Collections.emptyList()`, and is preferable mainly for consistency and maintainability of your code.

    - #### of

          public static <E> ImmutableList<E> of(E element)

      Returns an immutable list containing a single element. This list behaves and performs comparably to `Collections.singleton(T)`, but will not accept a null element. It is preferable mainly for consistency and maintainability of your code.
      Throws:
        `java.lang.NullPointerException` - if `element` is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5,
                                E e6)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5,
                                E e6,
                                E e7)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5,
                                E e6,
                                E e7,
                                E e8)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5,
                                E e6,
                                E e7,
                                E e8,
                                E e9)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5,
                                E e6,
                                E e7,
                                E e8,
                                E e9,
                                E e10)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5,
                                E e6,
                                E e7,
                                E e8,
                                E e9,
                                E e10,
                                E e11)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null

    - #### of

          public static <E> ImmutableList<E> of(E e1,
                                E e2,
                                E e3,
                                E e4,
                                E e5,
                                E e6,
                                E e7,
                                E e8,
                                E e9,
                                E e10,
                                E e11,
                                E e12,
                                E... others)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any element is null
      Since:
        3.0 (source-compatible since 2.0)

    - #### copyOf

          public static <E> ImmutableList<E> copyOf(java.lang.Iterable<? extends E> elements)

      Returns an immutable list containing the given elements, in order. If `elements` is a `Collection`, this method behaves exactly as `copyOf(Collection)`; otherwise, it behaves exactly as `copyOf(elements.iterator()`.
      Throws:
        `java.lang.NullPointerException` - if any of `elements` is null

    - #### copyOf

          public static <E> ImmutableList<E> copyOf(java.util.Collection<? extends E> elements)

      Returns an immutable list containing the given elements, in order.

      Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

      Note that if `list` is a `List<String>`, then `ImmutableList.copyOf(list)` returns an `ImmutableList<String>` containing each of the strings in `list`, while ImmutableList.of(list)} returns an `ImmutableList<List<String>>` containing one element (the given list itself).

      This method is safe to use even when `elements` is a synchronized or concurrent collection that is currently being modified by another thread.

      Throws:
        `java.lang.NullPointerException` - if any of `elements` is null

    - #### copyOf

          public static <E> ImmutableList<E> copyOf(java.util.Iterator<? extends E> elements)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any of `elements` is null

    - #### copyOf

          public static <E> ImmutableList<E> copyOf(E[] elements)

      Returns an immutable list containing the given elements, in order.
      Throws:
        `java.lang.NullPointerException` - if any of `elements` is null
      Since:
        3.0

    - #### iterator

          public UnmodifiableIterator<E> iterator()

      Description copied from class: `ImmutableCollection`
      Returns an unmodifiable iterator across the elements in this collection.
      Specified by:
        `iterator` in interface `java.lang.Iterable<E>`
      Specified by:
        `iterator` in interface `java.util.Collection<E>`
      Specified by:
        `iterator` in interface `java.util.List<E>`
      Specified by:
        `iterator` in class `ImmutableCollection<E>`

    - #### listIterator

          public UnmodifiableListIterator<E> listIterator()

      Specified by:
        `listIterator` in interface `java.util.List<E>`

    - #### listIterator

          public UnmodifiableListIterator<E> listIterator(int index)

      Specified by:
        `listIterator` in interface `java.util.List<E>`

    - #### indexOf

          public int indexOf(@Nullable
                    java.lang.Object object)

      Specified by:
        `indexOf` in interface `java.util.List<E>`

    - #### lastIndexOf

          public int lastIndexOf(@Nullable
                        java.lang.Object object)

      Specified by:
        `lastIndexOf` in interface `java.util.List<E>`

    - #### contains

          public boolean contains(@Nullable
                         java.lang.Object object)

      Specified by:
        `contains` in interface `java.util.Collection<E>`
      Specified by:
        `contains` in interface `java.util.List<E>`
      Specified by:
        `contains` in class `ImmutableCollection<E>`

    - #### subList

          public ImmutableList<E> subList(int fromIndex,
                                 int toIndex)

      Returns an immutable list of the elements between the specified `fromIndex`, inclusive, and `toIndex`, exclusive. (If `fromIndex` and `toIndex` are equal, the empty immutable list is returned.)
      Specified by:
        `subList` in interface `java.util.List<E>`

    - #### addAll

          @Deprecated
          public final boolean addAll(int index,
                                  java.util.Collection<? extends E> newElements)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the list unmodified.
      Specified by:
        `addAll` in interface `java.util.List<E>`
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### set

          @Deprecated
          public final E set(int index,
                         E element)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the list unmodified.
      Specified by:
        `set` in interface `java.util.List<E>`
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### add

          @Deprecated
          public final void add(int index,
                            E element)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the list unmodified.
      Specified by:
        `add` in interface `java.util.List<E>`
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### remove

          @Deprecated
          public final E remove(int index)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the list unmodified.
      Specified by:
        `remove` in interface `java.util.List<E>`
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### asList

          public final ImmutableList<E> asList()

      Returns this list instance.
      Overrides:
        `asList` in class `ImmutableCollection<E>`
      Since:
        2.0

    - #### reverse

          public ImmutableList<E> reverse()

      Returns a view of this immutable list in reverse order. For example, `ImmutableList.of(1, 2, 3).reverse()` is equivalent to `ImmutableList.of(3, 2, 1)`.
      Returns:
        a view of this immutable list in reverse order
      Since:
        7.0

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object obj)

      Specified by:
        `equals` in interface `java.util.Collection<E>`
      Specified by:
        `equals` in interface `java.util.List<E>`
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in interface `java.util.Collection<E>`
      Specified by:
        `hashCode` in interface `java.util.List<E>`
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### builder

          public static <E> ImmutableList.Builder<E> builder()

      Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableList.Builder` constructor.